SmSpr Web Server 3rd Party Dependencies
=======================================

# Core Library

chrono # date time handling (https://github.com/chronotope/chrono, MIT & Apache 2.0 License)
geojson # support for GeoJSON (https://github.com/georust/geojson, MIT & Apache 2.0 License)
josekit # JOSE implementation in Rust (https://github.com/hidekatsu-izuno/josekit-rs, MIT & Apache 2.0 License)
lazy_static # lazy initializations e.g. for regex (https://github.com/rust-lang-nursery/lazy-static.rs, MIT & Apache 2.0 License)
openssl # openssl bindings (https://github.com/sfackler/rust-openssl, MIT & Apache 2.0 License)
regex # standard regex lib (https://github.com/sfackler/rust-openssl, MIT & Apache 2.0 License)
serde # serialize framework (https://github.com/serde-rs/serde, MIT & Apache 2.0 License)
serde_json # serialize JSON support (https://github.com/serde-rs/json, MIT & Apache 2.0 License)
serde_repr # serialize enum members as number (https://github.com/dtolnay/serde-repr, MIT & Apache 2.0 License)
thiserror # derive error support (https://github.com/dtolnay/thiserror, MIT & Apache 2.0 License)
uuid # uuid library (https://github.com/uuid-rs/uuid, MIT & Apache 2.0 License)
validator # schema validation (https://github.com/Keats/validator, MIT License)

# Web Server

async-stream # support for async streams (https://github.com/tokio-rs/async-stream, ??)
async-trait # support for async traits (https://github.com/dtolnay/async-trait, MIT & Apache 2.0 License)
ciborium # serialize CBOR support (https://github.com/enarx/ciborium, Apache 2.0 License)
config # config file and parsing support (https://github.com/mehcode/config-rs, MIT & Apache 2.0 License)
futures # some traits and types to work with futures (https://github.com/rust-lang/futures-rs, MIT & Apache 2.0 License)
hostname # read out the hostname (https://github.com/svartalf/hostname, MIT License)
itertools # advanced iterator tools (https://github.com/rust-itertools/itertools, MIT & Apache 2.0 License)
md-5 # md 5 hashing function (https://github.com/RustCrypto/hashes, MIT & Apache 2.0 License)
rusty-leveldb # leveldb in rust-lang (https://github.com/dermesser/leveldb-rs, MIT License)

axum # Web framework from Tokio folks (https://github.com/tokio-rs/axum, MIT License)
axum-extra # additional macros for axum (https://github.com/tokio-rs/axum, MIT License)
axum-macros # improved debug infos for axum handlers (https://github.com/tokio-rs/axum, MIT License)
axum-server # axum server helpers e.g. for TLS/SSL (https://github.com/programatik29/axum-server, MIT License)
hyper # HTTP client / server based on Tokio (https://github.com/hyperium/hyper, MIT License)
tokio # async runtime (https://github.com/tokio-rs/tokio, MIT License)
tokio-stream # tokio async streams (https://github.com/tokio-rs/tokio, MIT License)
tower # tower service builder (https://github.com/tower-rs/tower, MIT License)
tower-http # http request tracing (https://github.com/tower-rs/tower-http, MIT License)
tracing # distributed log / tracing module from Tokio (https://github.com/tokio-rs/tracing, MIT License)
tracing-appender # tracing to log file (https://github.com/tokio-rs/tracing, MIT License)
tracing-subscriber # tracing to stdout (https://github.com/tokio-rs/tracing, MIT License)

mdns-sd # mdns library (https://github.com/keepsimple1/mdns-sd, MIT & Apache 2 License)
paho-mqtt # MQTT client wrapper for paho (https://github.com/eclipse/paho.mqtt.rust, Eclipse Public License 1.0)
